## kdsoap 2.2.0+dfsg

=== CMakeLists.txt ===
# This file is part of the KD Soap project.
#
# SPDX-FileCopyrightText: 2012 Klarälvdalens Datakonsult AB, a KDAB Group company <info@kdab.com>
#
# SPDX-License-Identifier: MIT
#

# This is the top-level CMakeLists.txt file for the KDSoap project.
#
# Pass the following variables to cmake to control the build:
# (See INSTALL.txt for more information)
#
# -DKDSoap_QT6=[true|false]
#  Build against Qt6 rather than Qt5
#  Default=false (Qt5 will be used even if Qt6 is available)
#
# -DKDSoap_STATIC=[true|false]
#  Build static libraries
#  Default=false
#
# -DKDSoap_TESTS=[true|false]
#  Build the test harness.
#  Default=false
#
# -DKDSoap_EXAMPLES=[true|false]
#  Build the examples.
#  Default=true
#
# -DKDSoap_DOCS=[true|false]
#  Build the API documentation. Enables the 'docs' build target.
#  Default=false
#

cmake_minimum_required(VERSION 3.12)

if(NOT EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/kdwsdl2cpp/libkode/common")
    message(FATAL_ERROR "Please do git submodule update --init --recursive")
endif()

# Allow using a non-KDAB install location.
set(KDAB_INSTALL
    True
    CACHE INTERNAL "Install to default KDAB Location"
)
if(DEFINED CMAKE_INSTALL_PREFIX)
    if(NOT "${CMAKE_INSTALL_PREFIX}" STREQUAL "")
        set(KDAB_INSTALL
            False
            CACHE INTERNAL "Install to non-KDAB Location"
        )
    endif()
endif()

project(
    KDSoap
    DESCRIPTION "A Qt-based client-side and server-side SOAP component"
    HOMEPAGE_URL "https://github.com/KDAB/KDSoap"
    LANGUAGES CXX
)

set(${PROJECT_NAME}_VERSION_MAJOR 2)
set(${PROJECT_NAME}_VERSION_MINOR 2)
set(${PROJECT_NAME}_VERSION_PATCH 0)
set(${PROJECT_NAME}_VERSION
    ${${PROJECT_NAME}_VERSION_MAJOR}.${${PROJECT_NAME}_VERSION_MINOR}.${${PROJECT_NAME}_VERSION_PATCH}
)
set(PROJECT_VERSION ${${PROJECT_NAME}_VERSION}) #needed for ECM
set(${PROJECT_NAME}_SOVERSION ${${PROJECT_NAME}_VERSION_MAJOR})

include(FeatureSummary)

option(${PROJECT_NAME}_STATIC "Build statically" OFF)
option(${PROJECT_NAME}_TESTS "Build the tests" OFF)
option(${PROJECT_NAME}_EXAMPLES "Build the examples" ON)
option(${PROJECT_NAME}_DOCS "Build the API documentation" OFF)
option(${PROJECT_NAME}_QT6 "Build against Qt 6" OFF)

list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake/ECM/modules")
list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake/KDAB/modules")

# Set a default build type if none was specified
set(default_build_type "Release")
if(EXISTS "${CMAKE_SOURCE_DIR}/.git" OR ${PROJECT_NAME}_DEVELOPER_MODE)
    set(default_build_type "Debug")
endif()
if(NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)
    message(STATUS "Setting build type to ${default_build_type} as none was specified.")
    set(CMAKE_BUILD_TYPE
        "${default_build_type}"
        CACHE STRING "Choose the type of build." FORCE
    )
    # Set the possible values of build type for cmake-gui
    set_property(
        CACHE CMAKE_BUILD_TYPE
        PROPERTY STRINGS
                 "Debug"
                 "Release"
                 "MinSizeRel"
                 "RelWithDebInfo"
    )
endif()

if(${PROJECT_NAME}_QT6)
    set(QT_VERSION_MAJOR 6)
    set(QT_MIN_VERSION "6.0.0")
    find_package(Qt6 ${QT_MIN_VERSION} CONFIG REQUIRED COMPONENTS Core Network)
    list(APPEND QT_LIBRARIES Qt6::Core Qt6::Network)
    set(${PROJECT_NAME}_LIBRARY_QTID "-qt6")
    set(libkode_QT6 ON)
else()
    set(QT_VERSION_MAJOR 5)
    # Qt 5.9 required for QNetworkRequest::NoLessSafeRedirectPolicy
    set(QT_MIN_VERSION "5.9.0")
    find_package(Qt5 ${QT_MIN_VERSION} CONFIG REQUIRED COMPONENTS Core Network)
    list(APPEND QT_LIBRARIES Qt5::Core Qt5::Network)
    set(${PROJECT_NAME}_LIBRARY_QTID "")
endif()
include(KDQtInstallPaths) #to set QT_INSTALL_FOO variables

find_path(BOOST_OPTIONAL_DIR NAMES boost/optional.hpp)
if(BOOST_OPTIONAL_DIR)
    message(STATUS "Found boost/optional.hpp in ${BOOST_OPTIONAL_DIR}")
    include_directories(${BOOST_OPTIONAL_DIR})
    add_definitions(-DBOOST_OPTIONAL_FOUND)
endif()

set(CMAKE_INCLUDE_CURRENT_DIR TRUE)
set(CMAKE_AUTOMOC TRUE)
set(CMAKE_AUTORCC ON)

set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
if(TARGET Qt6::Core)
    set(CMAKE_CXX_STANDARD 17)
endif()

# Default to hidden visibility for symbols
set(CMAKE_C_VISIBILITY_PRESET hidden)
set(CMAKE_CXX_VISIBILITY_PRESET hidden)
set(CMAKE_VISIBILITY_INLINES_HIDDEN 1)

include(KDCompilerFlags)

add_definitions(-DQT_NO_CAST_TO_ASCII -DQT_NO_CAST_FROM_ASCII -DQT_NO_CAST_FROM_BYTEARRAY -DQURL_NO_CAST_FROM_STRING)
add_definitions(-DUSE_EXCEPTIONS -DQT_FATAL_ASSERT -DQT_NO_FOREACH)
if(MSVC)
    add_definitions(-D_SCL_SECURE_NO_WARNINGS)
endif()

if(${PROJECT_NAME}_STATIC)
    set(${PROJECT_NAME}_LIBRARY_MODE "STATIC")
else()
    set(${PROJECT_NAME}_LIBRARY_MODE "SHARED")
endif()

if(KDAB_INSTALL)
    if(UNIX)
        set(CMAKE_INSTALL_PREFIX
            "/usr/local/KDAB/${PROJECT_NAME}-${${PROJECT_NAME}_VERSION}"
            CACHE INTERNAL "Install to default KDAB Location"
        )
    elseif(WIN32)
        set(CMAKE_INSTALL_PREFIX
            "C:\\KDAB\\${PROJECT_NAME}-${${PROJECT_NAME}_VERSION}"
            CACHE INTERNAL "Install to default KDAB Location"
        )
    endif()
endif()

# setup default install locations
include(KDInstallLocation)

if(CMAKE_SOURCE_DIR STREQUAL PROJECT_SOURCE_DIR)
    set(${PROJECT_NAME}_IS_ROOT_PROJECT TRUE)

    if(CMAKE_BUILD_TYPE MATCHES "Release")
        add_definitions(-DNDEBUG)
    endif()

    message(STATUS "Building ${PROJECT_NAME} ${${PROJECT_NAME}_VERSION} in ${CMAKE_BUILD_TYPE} mode. "
                   "Installing to ${CMAKE_INSTALL_PREFIX}"
    )

    set(CMAKE_RUNTIME_OUTPUT_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/bin")
    set(CMAKE_LIBRARY_OUTPUT_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/lib")
    set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/lib")

    install(FILES README.md DESTINATION ${INSTALL_DOC_DIR})
    if(NOT ${PROJECT_NAME}_QT6)
        install(FILES kdsoap.pri kdwsdl2cpp.pri DESTINATION ${INSTALL_DOC_DIR})
    endif()
    install(DIRECTORY LICENSES DESTINATION ${INSTALL_DOC_DIR})

    # Generate library version files
    include(ECMSetupVersion)
    ecm_setup_version(
        ${${PROJECT_NAME}_VERSION}
        VARIABLE_PREFIX
        KDSOAP
        VERSION_HEADER
        "${CMAKE_CURRENT_BINARY_DIR}/kdsoap_version.h"
        PACKAGE_VERSION_FILE
        "${CMAKE_CURRENT_BINARY_DIR}/KDSoap/KDSoap${${PROJECT_NAME}_LIBRARY_QTID}ConfigVersion.cmake"
        SOVERSION
        ${${PROJECT_NAME}_SOVERSION}
        COMPATIBILITY
        AnyNewerVersion
    )
    if(${PROJECT_NAME}_QT6)
        install(FILES "${CMAKE_CURRENT_BINARY_DIR}/kdsoap_version.h"
                DESTINATION ${INSTALL_INCLUDE_DIR}/KDSoapClient-Qt6/KDSoapClient
        )
    else()
        install(FILES "${CMAKE_CURRENT_BINARY_DIR}/kdsoap_version.h" DESTINATION ${INSTALL_INCLUDE_DIR}/KDSoapClient)
    endif()

    configure_file(
        "${CMAKE_CURRENT_SOURCE_DIR}/KDSoapConfig-buildtree.cmake.in"
        "${CMAKE_CURRENT_BINARY_DIR}/KDSoap/KDSoap${${PROJECT_NAME}_LIBRARY_QTID}Config.cmake" @ONLY
    )
    configure_file(
        "${CMAKE_CURRENT_SOURCE_DIR}/KDSoapMacros.cmake.in" "${CMAKE_CURRENT_BINARY_DIR}/KDSoap/KDSoapMacros.cmake"
        @ONLY
    )
    configure_package_config_file(
        "${CMAKE_CURRENT_SOURCE_DIR}/KDSoapConfig.cmake.in"
        "${CMAKE_CURRENT_BINARY_DIR}/install/KDSoap${${PROJECT_NAME}_LIBRARY_QTID}Config.cmake"
        INSTALL_DESTINATION "${INSTALL_LIBRARY_DIR}/cmake/KDSoap${${PROJECT_NAME}_LIBRARY_QTID}"
        PATH_VARS INSTALL_INCLUDE_DIR
    )

    install(
        FILES "${CMAKE_CURRENT_BINARY_DIR}/install/KDSoap${${PROJECT_NAME}_LIBRARY_QTID}Config.cmake"
              "${CMAKE_CURRENT_BINARY_DIR}/KDSoap/KDSoap${${PROJECT_NAME}_LIBRARY_QTID}ConfigVersion.cmake"
              "${CMAKE_CURRENT_BINARY_DIR}/KDSoap/KDSoapMacros.cmake"
        DESTINATION "${INSTALL_LIBRARY_DIR}/cmake/KDSoap${${PROJECT_NAME}_LIBRARY_QTID}"
    )

    install(
        EXPORT KDSoapTargets
        NAMESPACE KDSoap::
        DESTINATION "${INSTALL_LIBRARY_DIR}/cmake/KDSoap${${PROJECT_NAME}_LIBRARY_QTID}"
    )

    #Install the kdsoap features file for qmake users
    add_subdirectory(features)

    # Generate .pri file for qmake users (except when using the VS generator)
    if(NOT CMAKE_CONFIGURATION_TYPES)
        if(QT_VERSION_MAJOR EQUAL 5 OR (QT_VERSION_MAJOR EQUAL 6 AND Qt6Core_VERSION VERSION_GREATER "6.2"))
            include(ECMGeneratePriFile)
            ecm_generate_pri_file(
                BASE_NAME
                KDSoapClient
                LIB_NAME
                kdsoap${${PROJECT_NAME}_LIBRARY_QTID}
                FILENAME_VAR
                pri_client_filename
                INCLUDE_INSTALL_DIR
                ${INSTALL_INCLUDE_DIR}
            )
            ecm_generate_pri_file(
                BASE_NAME
                KDSoapServer
                LIB_NAME
                kdsoap-server${${PROJECT_NAME}_LIBRARY_QTID}
                FILENAME_VAR
                pri_server_filename
                INCLUDE_INSTALL_DIR
                ${INSTALL_INCLUDE_DIR}
            )
            install(FILES ${pri_client_filename} ${pri_server_filename} DESTINATION ${ECM_MKSPECS_INSTALL_DIR})
        endif()
    endif()
else()
    #Always disable tests, examples, docs when used as a submodule
    set(${PROJECT_NAME}_IS_ROOT_PROJECT FALSE)
    set(${PROJECT_NAME}_TESTS FALSE)
    set(${PROJECT_NAME}_EXAMPLES FALSE)
    set(${PROJECT_NAME}_DOCS FALSE)
endif()

if(${PROJECT_NAME}_TESTS)
    enable_testing()
endif()

add_subdirectory(src)
add_subdirectory(kdwsdl2cpp)

if(${PROJECT_NAME}_IS_ROOT_PROJECT)
    export(
        TARGETS kdsoap kdsoap-server kdwsdl2cpp
        NAMESPACE KDSoap::
        FILE "${CMAKE_CURRENT_BINARY_DIR}/KDSoap/KDSoapTargets.cmake"
    )
endif()

if(${PROJECT_NAME}_TESTS)
    add_subdirectory(testtools)
    add_subdirectory(unittests)
endif()

if(${PROJECT_NAME}_EXAMPLES)
    add_subdirectory(examples)
endif()

if(${PROJECT_NAME}_DOCS)
    add_subdirectory(docs) # needs to go last, in case there are build source files
endif()

if(${PROJECT_NAME}_IS_ROOT_PROJECT)
    # Add uninstall target (not for submodules since parent projects typically have uninstall too)
    include(ECMUninstallTarget)

    feature_summary(WHAT ALL INCLUDE_QUIET_PACKAGES FATAL_ON_MISSING_REQUIRED_PACKAGES)
endif()

=== docs/CMakeLists.txt ===
# This file is part of the KD Soap project.
#
# SPDX-FileCopyrightText: 2021 Klarälvdalens Datakonsult AB, a KDAB Group company <info@kdab.com>
#
# SPDX-License-Identifier: MIT
#

# Doxygen
find_package(Doxygen)
set_package_properties(
    Doxygen PROPERTIES
    TYPE OPTIONAL
    DESCRIPTION "API Documentation system"
    URL "https://www.doxygen.org"
    PURPOSE "Needed to build the API documentation."
)

if(DOXYGEN_FOUND)
    add_subdirectory(api)
endif()

=== features/CMakeLists.txt ===
# This file is part of the KD Soap project.
#
# SPDX-FileCopyrightText: 2012 Klarälvdalens Datakonsult AB, a KDAB Group company <info@kdab.com>
#
# SPDX-License-Identifier: MIT
#

if(NOT ${PROJECT_NAME}_QT6)
    install(FILES kdsoap.prf DESTINATION ${INSTALL_DATADIR}/mkspecs/features)
endif()

=== src/CMakeLists.txt ===
# This file is part of the KD Soap project.
#
# SPDX-FileCopyrightText: 2012 Klarälvdalens Datakonsult AB, a KDAB Group company <info@kdab.com>
#
# SPDX-License-Identifier: MIT
#

add_subdirectory(KDSoapClient)
add_subdirectory(KDSoapServer)

=== testtools/CMakeLists.txt ===
# This file is part of the KD Soap project.
#
# SPDX-FileCopyrightText: 2012 Klarälvdalens Datakonsult AB, a KDAB Group company <info@kdab.com>
#
# SPDX-License-Identifier: MIT
#

find_package(
    Qt${QT_VERSION_MAJOR} ${QT_MIN_VERSION}
    COMPONENTS Xml CONFIG
    REQUIRED
)
list(APPEND QT_LIBRARIES Qt${QT_VERSION_MAJOR}::Xml)

include_directories(.. ../src/KDSoapClient)

set(testtools_srcs httpserver_p.cpp testtools.qrc)

add_library(
    testtools STATIC
    ${testtools_srcs}
)
target_link_libraries(
    testtools ${QT_LIBRARIES}
)
if(Qt5_POSITION_INDEPENDENT_CODE)
    set_target_properties(testtools PROPERTIES POSITION_INDEPENDENT_CODE TRUE)
endif()

=== examples/bank_gui/CMakeLists.txt ===
# This file is part of the KD Soap project.
#
# SPDX-FileCopyrightText: 2019 Klarälvdalens Datakonsult AB, a KDAB Group company <info@kdab.com>
#
# SPDX-License-Identifier: MIT
#

project(bank_gui)

set(bank_gui_SRCS bank_gui.cpp mainwindow.cpp)

kdsoap_generate_wsdl(bank_gui_SRCS BLZService.wsdl)

add_executable(
    bank_gui
    ${bank_gui_SRCS} resources.qrc
)
target_link_libraries(
    bank_gui ${QT_LIBRARIES} kdsoap
)

=== examples/helloworld_client/CMakeLists.txt ===
# This file is part of the KD Soap project.
#
# SPDX-FileCopyrightText: 2012 Klarälvdalens Datakonsult AB, a KDAB Group company <info@kdab.com>
#
# SPDX-License-Identifier: MIT
#

project(helloworld_client)

set(helloworld_client_SRCS main.cpp helloworld_client.h)

kdsoap_generate_wsdl(helloworld_client_SRCS ../helloworld_server/helloworld.wsdl)

add_executable(
    helloworld_client
    ${helloworld_client_SRCS}
)
target_link_libraries(
    helloworld_client ${QT_LIBRARIES} kdsoap
)

=== examples/helloworld_server/CMakeLists.txt ===
# This file is part of the KD Soap project.
#
# SPDX-FileCopyrightText: 2012 Klarälvdalens Datakonsult AB, a KDAB Group company <info@kdab.com>
#
# SPDX-License-Identifier: MIT
#

project(helloworld_server)

set(KSWSDL2CPP_OPTION "-server")
set(helloworld_server_SRCS main.cpp helloworld_serverobject.cpp)

kdsoap_generate_wsdl(helloworld_server_SRCS helloworld.wsdl)

add_executable(
    helloworld_server
    ${helloworld_server_SRCS}
)
target_link_libraries(
    helloworld_server ${QT_LIBRARIES} kdsoap kdsoap-server
)

=== kdwsdl2cpp/libkode/CMakeLists.txt ===
# Pass the following variables to cmake to control the build:
#
# -Dlibkode_QT6=[true|false]
#  Build against Qt6 rather than Qt5
#  Default=false (Qt5 will be used even if Qt6 is available)

cmake_minimum_required(VERSION 3.11)
set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

project(libkode)

option(${PROJECT_NAME}_QT6 "Build against Qt 6" OFF)

if(${PROJECT_NAME}_QT6)
  find_package(Qt6 6.0.0 CONFIG REQUIRED COMPONENTS Core Network Xml Test)
  set(QT_MAJOR_VERSION 6)
  set(libkode_LIBRARY_QTID "-qt6")
else()
  # Qt 5.9 required for QNetworkRequest::NoLessSafeRedirectPolicy
  find_package(Qt5 5.9.0 CONFIG REQUIRED COMPONENTS Core Network Xml Test)
  set(QT_MAJOR_VERSION 5)
  set(libkode_LIBRARY_QTID "")
endif()

set(CMAKE_AUTOMOC ON)

set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/lib)

include_directories(SYSTEM
	${CMAKE_CURRENT_SOURCE_DIR}
	${CMAKE_CURRENT_SOURCE_DIR}/code_generation
)

enable_testing()

add_subdirectory(code_generation)
add_subdirectory(common)
add_subdirectory(schema)
add_subdirectory(autotests)

=== src/KDSoapServer/CMakeLists.txt ===
# This file is part of the KD Soap project.
#
# SPDX-FileCopyrightText: 2012 Klarälvdalens Datakonsult AB, a KDAB Group company <info@kdab.com>
#
# SPDX-License-Identifier: MIT
#

include_directories(.. ../KDSoapClient)

set(SOURCES
    KDSoapDelayedResponseHandle.cpp
    KDSoapServer.cpp
    KDSoapServerObjectInterface.cpp
    KDSoapServerSocket.cpp
    KDSoapServerThread.cpp
    KDSoapServerThread.cpp
    KDSoapServerThread.cpp
    KDSoapServerAuthInterface.cpp
    KDSoapServerRawXMLInterface.cpp
    KDSoapServerCustomVerbRequestInterface.cpp
    KDSoapSocketList.cpp
    KDSoapThreadPool.cpp
)

set_source_files_properties(KDSoapServerObjectInterface.cpp PROPERTIES SKIP_AUTOMOC TRUE)
add_library(
    kdsoap-server
    ${KDSoap_LIBRARY_MODE} ${SOURCES}
)
set_target_properties(kdsoap-server PROPERTIES OUTPUT_NAME "kdsoap-server${${PROJECT_NAME}_LIBRARY_QTID}")
if(${PROJECT_NAME}_STATIC)
    target_compile_definitions(kdsoap-server PUBLIC KDSOAPSERVER_STATICLIB)
else()
    target_compile_definitions(kdsoap-server PRIVATE KDSOAP_BUILD_KDSOAPSERVER_LIB)
endif()
target_link_libraries(
    kdsoap-server kdsoap ${QT_LIBRARIES}
)
if(${PROJECT_NAME}_QT6)
    set(server_INCLUDE_DIR ${INSTALL_INCLUDE_DIR}/KDSoapServer-Qt6)
else()
    set(server_INCLUDE_DIR ${INSTALL_INCLUDE_DIR})
endif()
target_include_directories(
    kdsoap-server
    INTERFACE "$<INSTALL_INTERFACE:${server_INCLUDE_DIR}>"
)
set_target_properties(
    kdsoap-server PROPERTIES SOVERSION ${${PROJECT_NAME}_SOVERSION} VERSION ${${PROJECT_NAME}_VERSION}
)

#version libraries on Windows
if(WIN32)
    set(postfix ${${PROJECT_NAME}_SOVERSION})
    string(TOUPPER ${CMAKE_BUILD_TYPE} UPPER_BUILD_TYPE)
    if(${UPPER_BUILD_TYPE} MATCHES "^DEBUG")
        string(CONCAT postfix ${postfix} "d")
        set_target_properties(kdsoap-server PROPERTIES DEBUG_POSTFIX ${postfix})
    else()
        set_target_properties(kdsoap-server PROPERTIES ${UPPER_BUILD_TYPE}_POSTFIX ${postfix})
    endif()
endif()

if(KDSoap_IS_ROOT_PROJECT)
    include(ECMGenerateHeaders)
    ecm_generate_headers(
        server_HEADERS
        ORIGINAL
        CAMELCASE
        HEADER_NAMES
        KDSoapDelayedResponseHandle
        KDSoapServerGlobal
        KDSoapThreadPool
        KDSoapServerObjectInterface
        KDSoapServerAuthInterface
        KDSoapServerRawXMLInterface
        KDSoapServerCustomVerbRequestInterface
        COMMON_HEADER
        KDSoapServer
    )

    set(COMBINED_H ${CMAKE_CURRENT_BINARY_DIR}/KDSoapServer)
    file(APPEND ${COMBINED_H} "#include \"KDSoapServer.h\"\n")

    install(
        FILES ${server_HEADERS}
              KDSoapServer.h
              KDSoapServerAuthInterface.h
              KDSoapServerRawXMLInterface.h
              KDSoapServerCustomVerbRequestInterface.h
              KDSoapDelayedResponseHandle.h
              KDSoapServerObjectInterface.h
              KDSoapServerGlobal.h
              KDSoapThreadPool.h
        DESTINATION ${server_INCLUDE_DIR}/KDSoapServer
    )

    install(
        TARGETS kdsoap-server
        EXPORT KDSoapTargets
        RUNTIME DESTINATION ${INSTALL_RUNTIME_DIR}
        LIBRARY DESTINATION ${INSTALL_LIBRARY_DIR}
        ARCHIVE DESTINATION ${INSTALL_ARCHIVE_DIR}
    )

    if(MSVC AND NOT ${PROJECT_NAME}_STATIC)
        install(
            FILES "$<TARGET_PDB_FILE_DIR:kdsoap-server>/$<TARGET_PDB_FILE_NAME:kdsoap-server>"
            DESTINATION ${INSTALL_RUNTIME_DIR}
            CONFIGURATIONS Debug RelWithDebInfo
        )
    endif()

endif()

=== kdwsdl2cpp/libkode/code_generation/CMakeLists.txt ===
set(CODE_GENERATION_SOURCES
	class.cpp
	code.cpp
	enum.cpp
	file.cpp
	function.cpp
	include.cpp
	license.cpp
	membervariable.cpp
	namer.cpp
	printer.cpp
	statemachine.cpp
	style.cpp
	typedef.cpp
	variable.cpp
)

set(CODE_GENERATION_HEADERS
	class.h
	code.h
	enum.h
	file.h
	function.h
	include.h
	kode_export.h
	license.h
	membervariable.h
	namer.h
	printer.h
	statemachine.h
	style.h
	typedef.h
	variable.h
)

add_library(kode STATIC
	${CODE_GENERATION_SOURCES} ${CODE_GENERATION_HEADERS}
)

target_link_libraries(kode
        Qt${QT_MAJOR_VERSION}::Core
)

target_include_directories(kode PUBLIC
        Qt${QT_MAJOR_VERSION}::Core
)

set_target_properties(kode PROPERTIES OUTPUT_NAME "kode${kode_LIBRARY_QTID}")

=== kdwsdl2cpp/libkode/common/CMakeLists.txt ===
set(COMMON_SOURCES
	fileprovider.cpp
	messagehandler.cpp
	nsmanager.cpp
	parsercontext.cpp
	qname.cpp
)

set(COMMON_HEADERS
	fileprovider.h
	messagehandler.h
	nsmanager.h
	parsercontext.h
	qname.h
)

add_library(xmlcommon STATIC
	${COMMON_SOURCES} ${COMMON_HEADERS}
)

target_link_libraries(xmlcommon
        Qt${QT_MAJOR_VERSION}::Network Qt${QT_MAJOR_VERSION}::Xml
)

target_include_directories(xmlcommon PUBLIC
   "$<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>"
)

set_target_properties(xmlcommon PROPERTIES OUTPUT_NAME "xmlcommon${kode_LIBRARY_QTID}")

=== debian/changelog ===
kdsoap (2.2.0+dfsg-5) unstable; urgency=medium

  [ Patrick Franz ]
  * Do not disable GCS warning anymore for arm64 (Closes: #1127152).
  * Bump Standards-Version to 4.7.3 (no changes needed).
  * Remove Priority: optional, not needed anymore.
  * Drop Rules-Requires-Root: no, not needed anymore.
  * Update d/watch to format version 5.

 -- Patrick Franz <deltaone@debian.org>  Wed, 11 Feb 2026 21:27:55 +0100

kdsoap (2.2.0+dfsg-4) unstable; urgency=medium

  [ Patrick Franz ]
  * Turn off warning for GCS on arm64 (Closes: #1110455).
  * Update d/copyright.
  * Bump Standards-Version to 4.7.2 (no changes needed).

 -- Patrick Franz <deltaone@debian.org>  Sun, 24 Aug 2025 23:05:59 +0200

kdsoap (2.2.0+dfsg-3) unstable; urgency=medium

  [ Pino Toscano ]
  * Pass -DKDSoap_EXAMPLES=OFF to stop building the examples: they are not
    installed or run anyway, and they cannot be cross-built. (Closes: #1024418)
  * Add a simple debian/upstream/metadata file.
  * debian/kdwsdl2cpp-qt6.1: minor fixes.

 -- Patrick Franz <deltaone@debian.org>  Sat, 08 Feb 2025 18:59:00 +0100

kdsoap (2.2.0+dfsg-2) unstable; urgency=medium

  * Team upload.
  * Add the configuration for the CI on salsa.
  * Switch Maintainer to Debian KDE Extras Team.
  * Update symbols files from the logs of buildds.
  * Remove field Section on binary package libkdsoap-bin that duplicates source.
  * Stop shipping the upstream README.md in libkdsoap-doc, as it does not
    provide a lot of value for users.
  * Enable the build of the QCH documentation:
    - add doxygen, qdoc-qt6, qt6-base-doc-dev, and qt6-tools-dev as
      Build-Depends-Indep
    - enable the cmake parameter -DKDSoap_DOCS only when building libkdsoap-doc
    - tweak the search of qhelpgenerator to look for it in libexec; patch
      qttools-paths.diff
    - update libkdsoap-doc.install

 -- Pino Toscano <pino@debian.org>  Sat, 01 Feb 2025 10:52:14 +0100

kdsoap (2.2.0+dfsg-1) unstable; urgency=medium

  [ Patrick Franz ]
  * New upstream release 2.2.0 (Closes: #1074108).
  * Set myself as maintainer (Closes: #1088328, #1093519).
  * Bump Standards-Version to 4.7.0 (no changes needed).
  * Update fields Vcs-Browser and Vcs-Git.
  * Update files to exclude.
  * Update build-deps and deps with the info from cmake.
  * New binary packages and update list of installed files.
  * Update d/copyright.

 -- Patrick Franz <deltaone@debian.org>  Tue, 28 Jan 2025 21:35:24 +0100

kdsoap (1.9.1+dfsg-6) unstable; urgency=medium

  * Orphan package, set maintainer to Debian QA Group. (See: #1093519)

 -- Thomas Pierson <contact@thomaspierson.fr>  Sun, 19 Jan 2025 15:27:32 +0100

=== debian/control ===
Source: kdsoap
Maintainer: Debian KDE Extras Team <pkg-kde-extras@alioth-lists.debian.net>
Uploaders: Patrick Franz <deltaone@debian.org>,
Build-Depends: debhelper-compat (= 13),
               dh-sequence-kf6,
               dh-sequence-pkgkde-symbolshelper,
               cmake (>= 3.12),
               libxkbcommon-dev,
               pkgconf,
               qt6-base-dev (>= 6.0.0~),
Build-Depends-Indep: doxygen,
                     qdoc-qt6,
                     qt6-base-doc-dev,
                     qt6-tools-dev,
Standards-Version: 4.7.3
Section: libs
Homepage: https://www.kdab.com/development-resources/qt-tools/kd-soap/
Vcs-Browser: https://salsa.debian.org/qt-kde-team/extras/kdsoap
Vcs-Git: https://salsa.debian.org/qt-kde-team/extras/kdsoap.git

Package: libkdsoap-bin
Architecture: any
Multi-Arch: foreign
Depends: ${misc:Depends}, ${shlibs:Depends},
Description: Qt-based client-side and server-side SOAP component - binaries
 Qt-based client-side and server-side SOAP component. It can be used to
 create client applications for web services and also provides the means to
 create web services without the need for any further component such as a
 dedicated web server.
 .
 This package contains some utilities and example programs for the library.

Package: libkdsoap-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libkdsoap-bin (= ${binary:Version}),
         libkdsoap-qt6-2 (= ${binary:Version}),
         libkdsoap-server-qt6-2 (= ${binary:Version}),
         ${misc:Depends},
Suggests: libkdsoap-doc,
Description: Qt-based client-side and server-side SOAP component - devel files
 Qt-based client-side and server-side SOAP component. It can be used to
 create client applications for web services and also provides the means to
 create web services without the need for any further component such as a
 dedicated web server.
 .
 This package contains the development files

Package: libkdsoap-doc
Section: doc
Architecture: all
Depends: ${misc:Depends},
Description: Qt-based client-side and server-side SOAP component - documentation
 Qt-based client-side and server-side SOAP component. It can be used to
 create client applications for web services and also provides the means to
 create web services without the need for any further component such as a
 dedicated web server.
 .
 This package contains the documentation.

Package: libkdsoap-qt6-2
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends},
Description: Qt-based client-side and server-side SOAP component - client-side library
 Qt-based client-side and server-side SOAP component. It can be used to
 create client applications for web services and also provides the means to
 create web services without the need for any further component such as a
 dedicated web server.
 .
 This package contains the client-side library

Package: libkdsoap-server-qt6-2
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends},
Description: Qt-based client-side and server-side SOAP component - server-side library
 Qt-based client-side and server-side SOAP component. It can be used to
 create client applications for web services and also provides the means to
 create web services without the need for any further component such as a
 dedicated web server.
 .
 This package contains the server-side library

=== debian/watch ===
Version: 5

Template: Github
Compression: xz
Dversionmangle: s/\+dfsg\d*$//
Owner: KDAB
Project: KDSoap
Repack: yes
Repacksuffix: +dfsg
